﻿$url = "https://services.qubedocs.com/Generate/Upload"

$token = $args[0]
$name = $args[1]
$tm1Directory = $args[2]  
$tm1sDirectory = $args[3]
$path = (Resolve-Path $tm1Directory).Path

$FileName = $path + "\QDPackage.7z"
if (Test-Path $FileName) 
{
  Remove-Item $FileName
}

Start-Process ./QUBEdocsFiles/QUBEdocs_CreatePackage.bat $args[2], $args[2], $("`"" + $args[3] + "`"") -Wait -RedirectStandardOutput ($tm1Directory + "/QUBEdocsFiles/package_output.txt") -NoNewWindow -WorkingDirectory $path

$ErrorActionPreference = 'Stop'
$fieldName = 'Package'

Try {
    Add-Type -AssemblyName 'System.Net.Http'

    $client = New-Object System.Net.Http.HttpClient
    $content = New-Object System.Net.Http.MultipartFormDataContent
    $fileStream = [System.IO.File]::OpenRead($path + "\QDPackage.7z")
    $fileName = [System.IO.Path]::GetFileName($path + "\QDPackage.7z")
    $fileContent = New-Object System.Net.Http.StreamContent($fileStream)
	
	$tokenContent = New-Object System.Net.Http.StringContent($Token)
    $nameContent = New-Object System.Net.Http.StringContent($Name)
	
	$content.Add($fileContent, $fieldName, $fileName)
	$content.Add($tokenContent, 'Token')
	$content.Add($nameContent, 'Name')

    $result = $client.PostAsync($url, $content).Result
    $result.EnsureSuccessStatusCode()
}
Catch {
    Write-Error $_
    exit 1
}
Finally {
    if ($client -ne $null) { $client.Dispose() }
    if ($content -ne $null) { $content.Dispose() }
    if ($fileStream -ne $null) { $fileStream.Dispose() }
    if ($fileContent -ne $null) { $fileContent.Dispose() }
}

Set-Location -Path $path